diff --git a/oflog/libsrc/cygwin32.cc b/oflog/libsrc/cygwin32.cc
new file mode 100644
index 0000000..828ad3d
--- /dev/null
+++ b/oflog/libsrc/cygwin32.cc
@@ -0,0 +1,49 @@
+// Module:  Log4CPLUS
+// File:    cygwin-win32.cxx
+// Created: 7/2011
+// Author:  Vaclav Zeman
+//
+//  Copyright (C) 2011, Vaclav Zeman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#if defined (__CYGWIN__)
+#include "dcmtk/oflog/internal/cygwin32.h"
+
+// This is intentionally included directly instead of through
+// windowsh-inc.h.
+#include <winsock2.h>
+
+
+namespace dcmtk {
+namespace log4cplus { namespace cygwin {
+
+unsigned long
+get_current_win32_thread_id ()
+{
+    return GetCurrentThreadId ();
+}
+
+} } // namespace log4cplus { namespace cygwin {
+} // end namespace dcmtk
+
+#endif // defined (__CYGWIN__)
diff --git a/oflog/libsrc/env.cc b/oflog/libsrc/env.cc
new file mode 100644
index 0000000..d8ffd58
--- /dev/null
+++ b/oflog/libsrc/env.cc
@@ -0,0 +1,103 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/internal/env.h"
+#include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/streams.h"
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_STDLIB_H
+#include <stdlib.h>
+#endif
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_WCHAR_H
+#include <wchar.h>
+#endif
+
+
+#include <cassert>
+#include <cstdlib>
+#include <sstream>
+
+
+namespace dcmtk {
+namespace log4cplus { namespace internal {
+
+
+bool
+get_env_var (tstring & value, tstring const & name)
+{
+#if defined (_WIN32) && defined (UNICODE)
+    tchar const * val = _wgetenv (name.c_str ());
+    if (val)
+        value = val;
+
+    return !! val;
+
+#else
+    char const * val
+        = getenv (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (name).c_str ());
+    if (val)
+        value = DCMTK_LOG4CPLUS_STRING_TO_TSTRING (val);
+
+    return !! val;
+
+#endif
+}
+
+
+bool
+parse_bool (bool & val, tstring const & str)
+{
+    log4cplus::tistringstream iss (STD_NAMESPACE string(str.c_str(), str.length()));
+    STD_NAMESPACE string word;
+    if (! (iss >> word))
+        return false;
+    tchar ch;
+    if (iss >> ch)
+        return false;
+    word = STD_NAMESPACE string (helpers::toLower (word.c_str()).c_str());
+
+    bool result = true;
+    if (word == DCMTK_LOG4CPLUS_TEXT ("true"))
+        val = true;
+    else if (word == DCMTK_LOG4CPLUS_TEXT ("false"))
+        val = false;
+    else
+    {
+        iss.clear ();
+        iss.seekg (0);
+        assert (iss);
+
+        long lval;
+        iss >> lval;
+        result = !! iss && ! (iss >> ch);
+        if (result)
+            val = !! lval;
+    }
+
+    return result;
+}
+
+
+} } // namespace log4cplus { namespace internal {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/factory.cc b/oflog/libsrc/factory.cc
index bc1db5e..3e1f216 100644
--- a/oflog/libsrc/factory.cc
+++ b/oflog/libsrc/factory.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2002-2009 Tad E. Smith
+// Copyright 2002-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,28 +20,19 @@
 
 #include "dcmtk/oflog/spi/factory.h"
 #include "dcmtk/oflog/spi/logfact.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/helpers/threadcf.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/asyncap.h"
 #include "dcmtk/oflog/consap.h"
 #include "dcmtk/oflog/fileap.h"
+#include "dcmtk/oflog/ntelogap.h"
 #include "dcmtk/oflog/nullap.h"
 #include "dcmtk/oflog/socketap.h"
 #include "dcmtk/oflog/syslogap.h"
-#include "dcmtk/oflog/helpers/loglog.h"
-#include "dcmtk/oflog/helpers/threads.h"
-
-#if defined (_WIN32)
-#  if defined (DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG)
-#    include "dcmtk/oflog/ntelogap.h"
-#  endif
-#  if defined (DCMTK_LOG4CPLUS_HAVE_WIN32_CONSOLE)
-#    include "dcmtk/oflog/winconap.h"
-#  endif
-#  include "dcmtk/oflog/windebap.h"
-#endif
-
-
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-using namespace dcmtk::log4cplus::spi;
+#include "dcmtk/oflog/windebap.h"
+#include "dcmtk/oflog/winconap.h"
+#include "dcmtk/oflog/log4judp.h"
 
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -49,182 +40,151 @@ using namespace dcmtk::log4cplus::spi;
 ///////////////////////////////////////////////////////////////////////////////
 
 namespace dcmtk {
-
 namespace log4cplus {
-
+    
 namespace spi {
 
-    BaseFactory::~BaseFactory()
-    { }
+BaseFactory::~BaseFactory()
+{ }
 
 
-    AppenderFactory::AppenderFactory()
-    { }
+AppenderFactory::AppenderFactory()
+{ }
 
-    AppenderFactory::~AppenderFactory()
-    { }
+AppenderFactory::~AppenderFactory()
+{ }
 
 
-    LayoutFactory::LayoutFactory()
-    { }
+LayoutFactory::LayoutFactory()
+{ }
 
-    LayoutFactory::~LayoutFactory()
-    { }
+LayoutFactory::~LayoutFactory()
+{ }
 
 
-    FilterFactory::FilterFactory()
-    { }
+FilterFactory::FilterFactory()
+{ }
 
-    FilterFactory::~FilterFactory()
-    { }
+FilterFactory::~FilterFactory()
+{ }
 
 
-    LoggerFactory::~LoggerFactory()
-    { }
+LocaleFactory::LocaleFactory()
+{ }
 
+LocaleFactory::~LocaleFactory()
+{ }
 
-} // namespace spi
+
+LoggerFactory::~LoggerFactory()
+{ }
 
 
 namespace
 {
 
-
-template <typename ProductFactoryBase>
-class LocalFactoryBase
-    : public ProductFactoryBase
+class GlobalLocale
+    : public LocalFactoryBase<LocaleFactory>
 {
 public:
-    LocalFactoryBase (tchar const * n)
-        : name (n)
+    GlobalLocale (tchar const * n)
+        : LocalFactoryBase<LocaleFactory> (n)
     { }
 
-    virtual tstring getTypeName()
+    virtual
+    ProductPtr
+    createObject (const log4cplus::helpers::Properties &)
     {
-        return name;
+        return STD_NAMESPACE locale ();
     }
-
-private:
-    tstring name;
 };
 
 
-template <typename LocalProduct, typename ProductFactoryBase>
-class FactoryTempl
-    : public LocalFactoryBase<ProductFactoryBase>
+class UserLocale
+    : public LocalFactoryBase<LocaleFactory>
 {
 public:
-    typedef typename ProductFactoryBase::ProductPtr ProductPtr;
-
-    FactoryTempl (tchar const * n)
-        : LocalFactoryBase<ProductFactoryBase> (n)
+    UserLocale (tchar const * n)
+        : LocalFactoryBase<LocaleFactory> (n)
     { }
 
-    virtual ProductPtr createObject (Properties const & props, tstring& error)
+    virtual
+    ProductPtr
+    createObject (const log4cplus::helpers::Properties &)
     {
-        error.clear();
-        ProductPtr ptr (new LocalProduct (props, error));
-        if (!error.empty())
-            return ProductPtr (0);
-        return ptr;
+        return STD_NAMESPACE locale ("");
     }
 };
 
 
-} // namespace
+class ClassicLocale
+    : public LocalFactoryBase<LocaleFactory>
+{
+public:
+    ClassicLocale (tchar const * n)
+        : LocalFactoryBase<LocaleFactory> (n)
+    { }
+
+    virtual
+    ProductPtr
+    createObject (const log4cplus::helpers::Properties &)
+    {
+        return STD_NAMESPACE locale::classic ();
+    }
+};
 
 
-#define REG_PRODUCT(reg, productprefix, productname, productns, productfact) \
-reg.put (                                                               \
-    OFauto_ptr<productfact> (                                        \
-        new FactoryTempl<productns productname, productfact> (          \
-            DCMTK_LOG4CPLUS_TEXT(productprefix)                               \
-            DCMTK_LOG4CPLUS_TEXT(#productname))))
+} // namespace
 
 
-#define REG_APPENDER(reg, appendername)                             \
-REG_PRODUCT (reg, "log4cplus::", appendername, dcmtk::log4cplus::, AppenderFactory)
 
-#define REG_LAYOUT(reg, layoutname)                                 \
-REG_PRODUCT (reg, "log4cplus::", layoutname, dcmtk::log4cplus::, LayoutFactory)
 
-#define REG_FILTER(reg, filtername)                                 \
-REG_PRODUCT (reg, "log4cplus::spi::", filtername, spi::, FilterFactory)
+} // namespace spi
 
 
 void initializeFactoryRegistry();
 void initializeFactoryRegistry()
 {
-    AppenderFactoryRegistry& reg = getAppenderFactoryRegistry();
-    REG_APPENDER (reg, ConsoleAppender);
-    REG_APPENDER (reg, NullAppender);
-    REG_APPENDER (reg, FileAppender);
-    REG_APPENDER (reg, RollingFileAppender);
-    REG_APPENDER (reg, DailyRollingFileAppender);
-    REG_APPENDER (reg, SocketAppender);
-#if defined(_WIN32) && !defined(__MINGW32__)
-#if defined(DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG)
-    REG_APPENDER (reg, NTEventLogAppender);
+    spi::AppenderFactoryRegistry& reg = spi::getAppenderFactoryRegistry();
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, ConsoleAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, NullAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, FileAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, RollingFileAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, DailyRollingFileAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, SocketAppender);
+#if defined(_WIN32)
+#  if defined(DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG)
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, NTEventLogAppender);
 #  endif
 #  if defined(DCMTK_LOG4CPLUS_HAVE_WIN32_CONSOLE)
-    REG_APPENDER (reg, Win32ConsoleAppender);
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, Win32ConsoleAppender);
 #  endif
-    REG_APPENDER (reg, Win32DebugAppender);
-#elif defined(DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
-    REG_APPENDER (reg, SysLogAppender);
-#endif // defined(_WIN32) && !defined(__MINGW32__)
-
-    LayoutFactoryRegistry& reg2 = getLayoutFactoryRegistry();
-    REG_LAYOUT (reg2, SimpleLayout);
-    REG_LAYOUT (reg2, TTCCLayout);
-    REG_LAYOUT (reg2, PatternLayout);
-
-    FilterFactoryRegistry& reg3 = getFilterFactoryRegistry();
-    REG_FILTER (reg3, DenyAllFilter);
-    REG_FILTER (reg3, LogLevelMatchFilter);
-    REG_FILTER (reg3, LogLevelRangeFilter);
-    REG_FILTER (reg3, StringMatchFilter);
-}
-
-
-
-
-///////////////////////////////////////////////////////////////////////////////
-// public methods
-///////////////////////////////////////////////////////////////////////////////
-
-namespace spi
-{
-
-
-AppenderFactoryRegistry&
-getAppenderFactoryRegistry()
-{
-    static AppenderFactoryRegistry singleton;
-    return singleton;
-}
-
-
-LayoutFactoryRegistry&
-getLayoutFactoryRegistry()
-{
-    static LayoutFactoryRegistry singleton;
-    return singleton;
-}
-
-
-FilterFactoryRegistry&
-getFilterFactoryRegistry()
-{
-    static FilterFactoryRegistry singleton;
-    return singleton;
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, Win32DebugAppender);
+#endif
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, SysLogAppender);
+#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, AsyncAppender);
+#endif
+    DCMTK_LOG4CPLUS_REG_APPENDER (reg, Log4jUdpAppender);
+
+    spi::LayoutFactoryRegistry& reg2 = spi::getLayoutFactoryRegistry();
+    DCMTK_LOG4CPLUS_REG_LAYOUT (reg2, SimpleLayout);
+    DCMTK_LOG4CPLUS_REG_LAYOUT (reg2, TTCCLayout);
+    DCMTK_LOG4CPLUS_REG_LAYOUT (reg2, PatternLayout);
+
+    spi::FilterFactoryRegistry& reg3 = spi::getFilterFactoryRegistry();
+    DCMTK_LOG4CPLUS_REG_FILTER (reg3, DenyAllFilter);
+    DCMTK_LOG4CPLUS_REG_FILTER (reg3, LogLevelMatchFilter);
+    DCMTK_LOG4CPLUS_REG_FILTER (reg3, LogLevelRangeFilter);
+    DCMTK_LOG4CPLUS_REG_FILTER (reg3, StringMatchFilter);
+
+    spi::LocaleFactoryRegistry& reg4 = spi::getLocaleFactoryRegistry();
+    DCMTK_LOG4CPLUS_REG_LOCALE (reg4, DCMTK_LOG4CPLUS_TEXT("GLOBAL"), spi::GlobalLocale);
+    DCMTK_LOG4CPLUS_REG_LOCALE (reg4, DCMTK_LOG4CPLUS_TEXT("DEFAULT"), spi::GlobalLocale);
+    DCMTK_LOG4CPLUS_REG_LOCALE (reg4, DCMTK_LOG4CPLUS_TEXT("USER"), spi::UserLocale);
+    DCMTK_LOG4CPLUS_REG_LOCALE (reg4, DCMTK_LOG4CPLUS_TEXT("CLASSIC"), spi::ClassicLocale);
 }
 
 
-} // namespace spi
-
-
 } // namespace log4cplus
-
-
-} // namespace dcmtk
+} // end namespace dcmtk
